unit hiDeferredEvent;

interface

uses Windows, Messages, Kol, Share, Debug;

type
 ThiDeferredEvent = class(TDebug)

   private
    FData: TData;
    PT: integer;        //    TThread
    TM: TThreadMethod;  //   FMethod   TThread
	Busy: boolean;
	FStop: boolean;
    procedure SyncMethod;
    procedure Delay(dwMilliseconds: DWORD);    
   public
     _prop_InData: boolean;
     _prop_Delay: cardinal;
     _prop_Data: TData;     
     _data_Data: THI_Event;
     _event_onDeferredEvent: THI_Event;
     _event_onStop: THI_Event;     
     constructor Create;
     procedure _work_doDeferredEvent(var _Data:TData; Index:word);
     procedure _work_doStop(var _Data:TData; Index:word);     
 end;

implementation

type
{$ifndef F_P}
  TThreadVirt = object(TThread) end;
  PThreadVirt = ^TThreadVirt;
{$else}
  TThreadVirt = class(TThread) end;
  PThreadVirt = TThreadVirt;
{$endif}

var Dummy: TThreadMethod;

procedure ThiDeferredEvent.Delay;
var
  SaveTickCount: Cardinal;
  Msg: TMsg;
begin
  SaveTickCount := GetTickCount;
  repeat
	if FStop then exit;
    if PeekMessage(Msg, 0, 0, 0, PM_REMOVE or PM_NOYIELD) then
    begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
  until GetTickCount - SaveTickCount >= dwMilliseconds;
end;

constructor ThiDeferredEvent.Create;
begin
  PT := integer(@@TM) - integer(@@PThreadVirt(nil).FMethod);
  TM := SyncMethod;
  Busy := false;
  FStop := false;
end;

procedure ThiDeferredEvent._work_doDeferredEvent;
begin
  if Busy then exit;
  if _prop_InData then
    FData := ReadData(_Data, _data_Data, @_prop_Data)
  else
    dtNull(FData);
  PostMessage(Applet.Handle, CM_EXECPROC, 0, PT);
  Busy := true;
  FStop := false;
end;

procedure ThiDeferredEvent._work_doStop;
begin
  FStop := true;
end;

procedure ThiDeferredEvent.SyncMethod;
begin
  if _prop_Delay <> 0 then Delay(_prop_Delay);
  if not FStop then
    _hi_OnEvent(_event_onDeferredEvent, FData)
  else
    _hi_OnEvent(_event_onStop);
  Busy := false;
end;

Initialization
  PThread(integer(@@Dummy) - integer(@@PThreadVirt(nil).FMethod)).Synchronize(Dummy);
  
end.